#include "l3ds.h"


////////////////////Cube definition////////////////////////////////

// Texture Array for method I
GLfloat vertexTexCoords[]={	1.0f, 0.0f, 1.0f, 1.0f, 0.0f, 1.0f, 0.0f, 0.0f,
								0.0f, 0.0f, 1.0f, 0.0f, 1.0f, 1.0f, 0.0f, 1.0f,
								1.0f, 1.0f, 0.0f, 1.0f, 0.0f, 0.0f, 1.0f, 0.0f,
								0.0f, 1.0f, 0.0f, 0.0f, 1.0f, 0.0f, 1.0f, 1.0f,
								0.0f, 0.0f, 1.0f, 0.0f, 1.0f, 1.0f, 0.0f, 1.0f,
								1.0f, 0.0f, 1.0f, 1.0f, 0.0f, 1.0f, 0.0f, 0.0};

// Vertex Array for method I
GLfloat vertexPositions[]={			-1.0f, -1.0f,  1.0f, -1.0f,  1.0f,  1.0f,
									 1.0f,  1.0f,  1.0f,  1.0f, -1.0f,  1.0f,
									-1.0f, -1.0f, -1.0f,  1.0f, -1.0f, -1.0f,
									 1.0f,  1.0f, -1.0f, -1.0f,  1.0f, -1.0f,
									-1.0f,  1.0f, -1.0f,  1.0f,  1.0f, -1.0f,
									 1.0f,  1.0f,  1.0f, -1.0f,  1.0f,  1.0f,
									-1.0f, -1.0f, -1.0f, -1.0f, -1.0f,  1.0f,
									 1.0f, -1.0f,  1.0f,  1.0f, -1.0f, -1.0f,
									 1.0f, -1.0f, -1.0f,  1.0f, -1.0f,  1.0f,
									 1.0f,  1.0f,  1.0f,  1.0f,  1.0f, -1.0f,
									-1.0f, -1.0f, -1.0f, -1.0f,  1.0f, -1.0f,
									-1.0f,  1.0f,  1.0f, -1.0f, -1.0f,  1.0f};


// Vertex Array for method II
GLfloat vertexPositions2[] = { -1.0f, 1.0f, 1.0f,    //front
				        1.0f, 1.0f, 1.0f,    //1
				        1.0f,-1.0f, 1.0f,    //2
				       -1.0f,-1.0f, 1.0f,    //3
				       -1.0f, 1.0f,-1.0f,    //4
				        1.0f, 1.0f,-1.0f,    //5
				        1.0f,-1.0f,-1.0f,    //6
				       -1.0f,-1.0f,-1.0f  }; //7

// Vertex Array for method II
GLfloat vertexColors[] = { 0.0f, 1.0f, 1.0f,    //front
				        1.0f, 1.0f, 1.0f,    //1
				        1.0f, 0.0f, 1.0f,    //2
				       0.0f,0.0f, 1.0f,    //3
				       0.0f, 1.0f,0.0f,    //4
				        1.0f, 1.0f,0.0f,    //5
				        1.0f,0.0f,0.0f,    //6
				       0.0f,0.0f,0.0f  }; //7


// Index Array for method II
GLubyte indices[] = {	3, 2, 1, 0,		//front
						0, 1, 5, 4,		//top
						7, 6, 2, 3,		//bottom
						6, 7, 4, 5,		//back
						2, 6, 5, 1,		//right
						7, 3, 0, 4  };	//left


//Lemming mesh
//Vertices XYZW (vec4) float
//indices GL_UNSIGNED_SHORT
//Primitives: triangles


L3DS scene3DS;
LColor3 *colorArray;
void initModel(){
	scene3DS.LoadFile("Lemming1.3ds");
	scene3DS.GetMesh(0).Optimize(oFull);

	LMesh &mesh = scene3DS.GetMesh(0);

	colorArray=new LColor3[mesh.GetVertexCount()];
	for(int i=0; i<mesh.GetTriangleCount(); i++){
		LColor3 col=scene3DS.GetMaterial(mesh.GetTriangle2(i).materialId).GetDiffuseColor();
		colorArray[mesh.GetTriangle(i).a]=col;
		colorArray[mesh.GetTriangle(i).b]=col;
		colorArray[mesh.GetTriangle(i).c]=col;		
	}
	std::cout<<scene3DS.GetMeshCount()<<"\n";
}

GLfloat *getModelVertices(int m=0){
	LMesh &mesh = scene3DS.GetMesh(0);
//	mesh.Optimize(oFull);
	return (GLfloat *)&mesh.GetVertex(0);
}

GLfloat *getModelNormals(int m=0){
	LMesh &mesh = scene3DS.GetMesh(0);
	return (GLfloat *)&mesh.GetNormal(0);
}
GLfloat *getModelColors(int m=0){
	return (GLfloat*)colorArray;
}

unsigned short *getModelIndices(int m=0){
	LMesh &mesh = scene3DS.GetMesh(0);
	return (unsigned short *)&mesh.GetTriangle(0);
}


int getModelNumIndices(int m=0){
	LMesh &mesh = scene3DS.GetMesh(0);
	return mesh.GetTriangleCount()*3;
}